/*********************************************************
 *
 * utility functions
 *
 * Copyright (c) 2001 Christian Ensel
 *
 *********************************************************/

#ifndef UTIL_H
#define UTIL_H



/*extern TCHTBL far actionWheelTch[];

#define OBJ_FULLSCREEN 0x8FFE
extern TCHTBL far fullscreen_tchtbl[];
*/

extern TCHTBL FAR empty[];
/*must point to last entry of array above! */
#define TCHTBL_END empty[0] /* actionWheelTch[3]*/

/*
extended version of LibSelWindowExt()
- automatically calculates width,
- able to center window on x and/or y axis (just set x and/or y to -1)
- displays a menu title,
- allows rtv==null (returns the selected line nr)
*/
byte SelWindowExt2(int x, int y, char *title, byte sel, byte *items, byte *rtv );



/*tell whether secret mode is active*/
bool inSecretMode();

#define  CURRENT_FILE_MODE ( inSecretMode()? IMB_FILE_SECRET_MODE : IMB_FILE_OPEN_MODE )



/* gets current time, daylight-saving is taken into account */
void getTime(int *h, int *m, int *s);

/* gets current date, daylight-saving is taken into account */
void getDate(word *y, int *m, int *d);

#define TEST  /* activate latest code for V3.2 (in whole PVMerlin) */
#define TEST1 /* activate latest code for V3.2 (in whole PVMerlin) that was at first intended for V4, this mainly concerns Category "All" */

#define TEST2 /* activate latest code for V4 (in whole PVMerlin) */
#ifdef TEST2 /*V4*/
  #ifndef TEST
    #define TEST 
  #endif     
#else /* <V4 */
  #ifndef ALLOWDEBUGCODE
    #define ALLOWDEBUGCODE  /* Versions <4 still run with debug code and option */
  #endif     
#endif
    

#define YSPACE2 "\x002"
#define YSPACE3 "\x003"
#define YSPACE4 "\x003"
#define BOLD "\x0ff"


int printCharArray(int x, int y, char **txt, int width, byte font);

/* returns TRUE for normal touch, FALSE for <esc> */
int waitForClick();

bool isInternationalAlphaNum(char c);

unsigned char internationalToupper( int c );

#endif
